#include <EEPROM.h>
#include <OneWire.h>
#include <DallasTemperature.h>
#include "LiquidCrystal_1602_RUS.h"
#include <HX711.h>  


OneWire  oneWire(2); // датчик температуры подключен к выводу D2
DallasTemperature ds(&oneWire);
LiquidCrystal_1602_RUS lcd(8, 9, 4, 5, 6, 7);
//LiquidCrystal_1602_RUS lcd(9, 10, 5, 6, 7, 8);// Инициализация пинов экрана

HX711 scale(A2, A1); 

// адреса датчиков t
DeviceAddress sensor1 = {0x28, 0xFF, 0x81, 0xC5, 0x92, 0x16, 0x04, 0xB6};//царга
DeviceAddress sensor2 = {0x28, 0xFF, 0xC8, 0x20, 0xC0, 0x16, 0x05, 0x0E};//дэф
DeviceAddress sensor3 = {0x28, 0xFF, 0x74, 0x0F, 0xC0, 0x16, 0x05, 0x8A};//куб


float tempOUTon;  // массив с температурой включения выхода
int temp;

float tempSensor[3]; // массив куда читается температура
float ves; //значение полученной разницы в весе в единицу времи
float vess[5];
float WWW; 
byte qty; // количество градусников на шине.
byte KEY; // значение нажатой кнопки

int motor=30;
int motora;
int otbor;
int vremia;
int item = 0; //номер экрана меню

long vesMillis = 0;  
long previousMillis = 0;  
long razbegMillis = 0; // храним время последнего включения кнопки 

unsigned long myScaleMillis = 0;
unsigned long time; // таймеры


float myScaleL;  // Инициализируем переменную в которой будем хранить текущий вес
float myScaleH; // измеренный вес
int vestelo;
float tmotor;

int Tsensorf = 0 ;// флаг тревоги при отсутствии датчика t1
int Tsensorh = 0 ;// флаг тревоги при отсутствии датчика t2
int Tsensorj = 0;// флаг тревоги при отсутствии датчика t3
int g=50; // предел для включения тревоги по отсутствию датчика t
int f=0;//переменная для расчета (t1)
int h=0;// переменная для расчета (t2)
int j=0;//переменная для расчета (t3)

void readSet(){ // считываем EEPROM по сохраненной температуре и мощности
EEPROM.get(0, otbor);
EEPROM.get(5, vestelo);
EEPROM.get(10, vremia);
EEPROM.get(15, temp);
}

void getTemp(){ // читаем температуру с датчиков и заполняем массив
   ds.requestTemperatures();    
   
   
   tempSensor[0] = ds.getTempC(sensor1); 
   tempSensor[1] = ds.getTempC(sensor2); 
   tempSensor[2] = ds.getTempC(sensor3);

}

 byte Key(){// проверяем кнопки шилда
  if (analogRead(0) < 50) return 3; // вправо
  else if (analogRead(0) < 180) return 2; //вниз
  else if (analogRead(0) < 360) return 4;// вверх
  else if (analogRead(0) < 550) return 1; // влево
  else if (analogRead(0) < 800) return 5; //sekect
  else if (analogRead(0) < 1023) return 0;
}
  

void setup() {
  Serial.begin(9600);
  pinMode(12, OUTPUT);   
digitalWrite(12, LOW);

ds.begin(); 
ds.setResolution(sensor1, 12); // определяем разрешение датчика температуры
ds.setResolution(sensor2, 11);
ds.setResolution(sensor3, 11);

    
qty = ds.getDeviceCount(); // при включении, сохраняем количество градусников, 
                             // можно и лучше количество указать руками. 
                             
scale.set_scale(385.65);                          // Устанавливаем для весов калибровочный коэффициент 
myScaleL = scale.get_units(20); 
   

lcd.begin(16, 2);  // включаем экран
lcd.clear();       // очищаем экран
}

void loop() {

    //убираем дребезг кнопок
 Key();  
if (Key() == 0) KEY = 0;
if (Key() != 0){
if (millis() - previousMillis >= 250) { // 250 интервал между включениями кнопок
previousMillis = millis(); 
KEY = Key();
}
else KEY = 0;
}

readSet();  // читаем настройки из еепром 
tempOUTon = temp / 10.0; 

if (Key() == 0) getTemp();// если нажимается кнопка, температура не считывается

 if (tempSensor[0] < 0) 
{
tempSensor[0] = 0; 
 f++;
 if (f > g) Tsensorf = 1;// если датчика нет несколько секунд, появляется ошибка   
}
else {
  Tsensorf = 0;// иначе ошибки нет
f=0;
}
// датчик №2
if (tempSensor[1] < 0)  {
tempSensor[1] = 0; 
    h++;
   if (h > g) Tsensorh = 1;
}
else {
  Tsensorh = 0;
h=0;
}
// датчик №3
if (tempSensor[2] < 0)  {
 tempSensor[2] = 0; 
    j++;
   if (j > g) Tsensorj = 1;
}
else {
  Tsensorj = 0;
j=0;
}
   if (millis() - vesMillis >= vremia*1000 && Key() == 0){            // ждем 15 секунд
  vesMillis = millis(); 
  scale.power_up();                                 // Отключаем энергосберегающий режим hx711
  myScaleH=scale.get_units(20);                 // Запоминаем текущий вес
  scale.power_down();  
  WWW=tempSensor[1] - tmotor;
   tmotor=tempSensor[1];
   }
   if (millis() - razbegMillis >10000 && tempSensor[0] >=70 && tempSensor[1]<70){            // ждем 15 секунд
  razbegMillis = millis(); 
      if ( WWW >= 0.7) motor = 7;
     if (tempSensor[1]<70 && WWW <= 0) motor = 8;
motora=motor;
  if (KEY != 1 && KEY != 3) Serial.write(motor);
   motor = 0;
   }
 if (millis() - myScaleMillis >= vremia*1000 && tempSensor[0] >=70 && tempSensor[1]>=70){            // ждем 15 секунд
   myScaleMillis = millis();
  ves=myScaleH-myScaleL;                                // определяем разницу в весе
    myScaleL = myScaleH;
 
 //  WWW=tempSensor[1] - tmotor; 
vess[0] = otbor*0.810*vremia*0.2/3600;
vess[1] = otbor*0.810*vremia*0.7/3600;
vess[2] = otbor*0.810*vremia*1.2/3600;
vess[3] = otbor*0.810*vremia*2.0/3600;
vess[4] = otbor*0.810*vremia*2.5/3600;
 
  if (ves >= vess[2] && ves < vess[3] && WWW >= 0 ) motor = 1; // если отбор более 330мл/ч но менее 366 то уменьшаем ток на 0,1А
  if (ves >= vess[3] && ves < vess[4] && WWW >= 0 ) motor = 2;// если отбор более 366мл/ч но менее 390 то уменьшаем ток на 0,2А
  if (ves >= vess[4] && WWW >= 0 ) motor = 3;  // если отбор более 390мл/ч то уменьшаем ток на 0,3А
  if (ves < vess[1] && ves >= vess[0] && WWW <= 0 && tempSensor[0] < tempOUTon ) motor = 4;  // если отбор менее 270мл/ч то увеличиваем ток на 0,1А
   if (ves < vess[0] && WWW <= 0 && tempSensor[0] < tempOUTon ) motor = 5;
   
//  tmotor=tempSensor[1];
  motora=motor;
  if (KEY != 1 && KEY != 3) Serial.write(motor);
   motor = 0;
} 

// сверяем температуру и управляем выходами

 if (tempSensor[0] >= tempOUTon && tempSensor[1] >= 70)  {
  digitalWrite(12, HIGH);
  motor = 6; // включение клапана
 Serial.write(motor);
 }
 if ( tempSensor[0] < tempOUTon && motor == 6)  {
 digitalWrite(12, LOW); 
  motor = 0; // включение клапана
 Serial.write(motor);
 }
//   включение тревоги (+пищалка), управление тэном


    if ( tempSensor[2] >= 99 || myScaleH >= vestelo)// сенсор 1 температура в самом вверху колонны,// сенсор2 темпер куба.// порог срабатывания тревоги при превышении на 0,3градуса
 { 
 tone(3, 2000, 300); // включаем пищалку
  delay (300);
 }
  else    {
  noTone(3);// выключаем пищалку
} 



 
// главный экран, отбор тела
  if (item == 0){
  lcd.setCursor(0, 0); 
  lcd.print (tempSensor[0], 1);  // показываем температуру с датчика царги
  lcd.setCursor(5, 0); 
  lcd.print (tempSensor[1], 1);  // показываем температуру с датчика дефа
  lcd.setCursor(10, 0); 
  lcd.print (tempSensor[2], 1);  // показываем температуру с датчика куба
  lcd.print (" ");
 lcd.print (motora);  
  lcd.setCursor(0, 1);
  lcd.print(tempOUTon, 1); // показываем установленную температуру дельты
  
  lcd.print (" ");
 lcd.print (vestelo);   
 lcd.print ("/");
 lcd.print (myScaleH);
  lcd.print ("   ");
 
     if (KEY == 1){//  шагаем следующее меню
       motor = 2; // включение клапана
      Serial.write(motor);
  
     KEY = 0;
     }
     if (KEY == 3){//  шагаем следующее меню
       motor = 5; // включение клапана
      Serial.write(motor);

     KEY = 0;
     }
    if (KEY == 4) { // если нажата кнопка
      temp = temp - 1;   // изменяем значение
        if (temp < 600) temp = 990;
        if (temp > 990) temp = 600;
     EEPROM.put(15, temp); // сохраняем в еепром
      KEY = 0;
     }
     
      if (KEY == 2){
       temp = temp + 1;
         if (temp > 990) temp = 600;
         if (temp < 600) temp = 990;
         EEPROM.put(15, temp); 
          KEY = 0;
     } 
       
     if (KEY == 5){//  шагаем следующее меню
     item = 1;
     lcd.clear();
     KEY = 0;
     } 
     
}

 if (item == 1) // настройка весов
  {    
    lcd.setCursor(0, 0);
    lcd.print(L"Значение веса"); 
    lcd.setCursor(0, 1);
    lcd.print(vestelo);
        
    lcd.print("   ");
     // выбор температуры дельты
    if (KEY == 4) { // если нажата кнопка
      vestelo=vestelo-10;   // изменяем значение
        if (vestelo < 0) vestelo = 3300;
        if (vestelo > 3300) vestelo = 0;
      EEPROM.put(5, vestelo); // сохраняем в еепром
      KEY = 0;
     }
     if (KEY == 2){
      vestelo=vestelo+10;   // изменяем значение
        if (vestelo < 0) vestelo = 3300;
        if (vestelo > 3300) vestelo = 0;
      EEPROM.put(5, vestelo); // сохраняем в еепром
          KEY = 0;
     }
 
         if (KEY == 3){
      item = 2; // 
     lcd.clear();
     KEY = 0;
     } 
          if (KEY == 5){//  шагаем следующее меню
     item = 0;
     lcd.clear();
     KEY = 0;
     } 
 }
  if (item == 2) // настройка скорости отбора
  {    
    lcd.setCursor(0, 0);
    lcd.print(L"Скорость отбора"); 
    lcd.setCursor(0, 1);
    lcd.print(otbor);
    lcd.print(L"мл");
    lcd.print("   ");
     // выбор температуры дельты
    if (KEY == 4) { // если нажата кнопка
      otbor=otbor-10;   // изменяем значение
        if (otbor < 40) otbor = 1000;
        if (otbor > 1000) otbor = 40;
      EEPROM.put(0, otbor); // сохраняем в еепром
      KEY = 0;
     }
     if (KEY == 2){
      otbor=otbor+10;   // изменяем значение
        if (otbor < 40) otbor = 1000;
        if (otbor > 1000) otbor = 40;
      EEPROM.put(0, otbor); // сохраняем в еепром
          KEY = 0;
     }
          if (KEY == 1){
      item = 1; // 
     lcd.clear();
     KEY = 0;
     } 
         if (KEY == 3){
      item = 3; // 
     lcd.clear();
     KEY = 0;
     } 
          if (KEY == 5){//  шагаем следующее меню
     item = 0;
     lcd.clear();
     KEY = 0;
     } 
 }
   if (item == 3) // интервал отбора
  {    
    lcd.setCursor(0, 0);
    lcd.print(L"интервал отбора"); 
    lcd.setCursor(0, 1);
    lcd.print(vremia);
    lcd.print(L"сек");
    lcd.print("   ");
     // выбор температуры дельты
    if (KEY == 4) { // если нажата кнопка
      vremia=vremia-1;   // изменяем значение
        if (vremia < 5) vremia = 60;
        if (vremia > 60) vremia = 5;
      EEPROM.put(10, vremia); // сохраняем в еепром
      KEY = 0;
     }
     if (KEY == 2){
      vremia=vremia+1;   // изменяем значение
        if (vremia < 5) vremia = 60;
        if (vremia > 60) vremia = 5;
      EEPROM.put(10, vremia); // сохраняем в еепром
          KEY = 0;
     }
          if (KEY == 1){
      item = 2; // 
     lcd.clear();
     KEY = 0;
     } 
 
          if (KEY == 5){//  шагаем следующее меню
     item = 0;
     lcd.clear();
     KEY = 0;
     } 
 }
}
